<?php

defined( '_JEXEC' ) or die( 'Restricted access' );
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

/**
 * @package RealEstateManager LocationMap
 * @copyright  OrdaSoft
 * @author  2020 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru)
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @description Location map for RealEstateManager
*/

// if(version_compare(JVERSION, "3.0.0","lt"))
// JHTML::_('behavior.mootools');
// else
// JHTML::_('behavior.framework', true);

if (!array_key_exists('realestatemanager_configuration', $GLOBALS) ||
      array_key_exists('realestatemanager_configuration', $GLOBALS)
      && !count($GLOBALS['realestatemanager_configuration'])) {
    require_once (JPATH_BASE .
     "/administrator/components/com_realestatemanager/realestatemanager.class.conf.php");
    $GLOBALS['realestatemanager_configuration'] = $realestatemanager_configuration;
} else
    global $realestatemanager_configuration;

$pr = rand();
?>
<?php
$url = JURI::base();

// $mosConfig_live_site = $GLOBALS['mosConfig_live_site'] = substr_replace($url, '', -1, 1);
$mosConfig_live_site = $GLOBALS['mosConfig_live_site'] = substr_replace($url, '', -1, 1) . '/';

$mosConfig_absolute_path = $GLOBALS['mosConfig_absolute_path'] = JPATH_SITE;

$doc = JFactory::getDocument();
$database = JFactory::getDBO();

$langContent = modREMLocationHelper::getLang();

if($params->get('GeoCodingBy') == '0'){
  //GeoCodingBy Google

  $api_key = "";
  if (isset($realestatemanager_configuration['api_key']) && $realestatemanager_configuration['api_key']) {
    $api_key = "key=" . $realestatemanager_configuration['api_key'];
  } else {
    JFactory::getApplication()->enqueueMessage("<a target='_blank' href='//developers.google.com/maps/documentation/geocoding/get-api-key'>" . _REALESTATE_MANAGER_GOOGLEMAP_API_KEY_LINK_MESSAGE . "</a>", _REALESTATE_MANAGER_GOOGLEMAP_API_KEY_ERROR);
  }

  $doc->addScript("//maps.googleapis.com/maps/api/js?$api_key&libraries=places");
} else{
  //GeoCodingBy OpenMap


  }

//Common parameters
//Individual parameters
$count_estates = intval($params->def('estates', 0));
$cat_id = $params->get('cat_id');
$estate_id = $params->get('estate_id');
$new_target = $params->def('new_target', 1);
if($params->def('new_target', 1)){
  $new_target = '_blank';
}else{
  $new_target = '_self';
}
$ItemId_tmp_from_params = $params->get('ItemId');
$moduleclass_sfx = $params->get('moduleclass_sfx');
$path = $mosConfig_absolute_path.'/components/com_realestatemanager/functions.php';
if (!file_exists($path)){
    echo "To display the featured house You have to install RealEstateManager first<br />"; exit;
} else{
    require_once($path);
}

$database->SetQuery("SELECT id  FROM #__menu WHERE menutype like '%menu%' AND link LIKE " .
  " '%option=com_realestatemanager%' AND params LIKE '%back_button%' ");
$Itemid_from_db = $database->loadResult();
if ($ItemId_tmp_from_params!=''){
    $Itemid = $ItemId_tmp_from_params;
} else{
    $Itemid = $Itemid_from_db;
}

  $s=modREMLocationHelper::getWhereUsergroupsString("c");

   $query = "SELECT language FROM #__modules WHERE id = '$module->id'";
   $database->setQuery($query);
   $langmodule = $database->loadResult();

  $sql_published = " AND h.published=1";
  $sql_approved = " AND h.approved=1";

if ($cat_id != null && $estate_id != null)
echo ('<font color="#CC0000">You input IDs of categories and estates together! Correct this mistake.</font>');
else
{
   if($estate_id != null) $sql_where = " AND h.id IN(".$estate_id.")";
   if($cat_id != null) $sql_where = " AND c.id IN(".$cat_id.")";
   if($cat_id == null && $estate_id == null) $sql_where = "";

  $langContent = modREMLocationHelper::getLang();

if (isset($langContent)){
    $lang = $langContent;
    // $query = "SELECT lang_code FROM #__languages WHERE sef = '$lang'";
    // $database->setQuery($query);
    // $lang = $database->loadResult();
    $lang = " and (h.language like 'all' or h.language like '' or h.language like '*' or h.language is null
            or h.language like '$lang')
            AND (c.language like 'all' or c.language like '' or c.language like '*' or c.language is null
            or c.language like '$lang') ";
}else{
    $lang = "";
}

   if($langmodule != "" && $langmodule != "*"){
            $selectstring = "SELECT h.htitle,h.id,h.houseid,h.hlatitude,h.hlongitude,hc.idcat,h.property_type,h.image_link,h.price,h.priceunit, map_zoom
                             \nFROM #__rem_houses AS h
                             \nLEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
                             \nLEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
                             \nWHERE ($s) $lang AND h.language = '".$langmodule."' AND h.hlatitude IS NOT
                               NULL".$sql_where.$sql_published.$sql_approved . " GROUP BY h.id " .
                            "\nLIMIT ".$count_estates;
   }
   else{
            $selectstring = "SELECT h.htitle,h.id,h.houseid,h.hlatitude,h.hlongitude,hc.idcat,h.property_type,h.image_link,h.price,h.priceunit, map_zoom
                             \nFROM #__rem_houses AS h
                             \nLEFT JOIN #__rem_categories AS hc ON hc.iditem=h.id
                             \nLEFT JOIN #__rem_main_categories AS c ON c.id=hc.idcat
                             \nWHERE ($s) $lang AND h.hlatitude IS NOT NULL".$sql_where.$sql_published.
                              $sql_approved . " GROUP BY h.id " .
                            "\nLIMIT ".$count_estates;
   }
            $database->setQuery($selectstring);
            $rows= $database->loadObjectList();
}
?>
<div class="rm_map realestatemanager_<?php if($moduleclass_sfx!='') echo $moduleclass_sfx; ?>">

<noscript>Javascript is required to use Real Estate Manager <a href="http://ordasoft.com/Real-Estate-Manager/realestatemanager-basic-and-pro-feature-comparison.html">Real estate manager Joomla extension for Real Estate Brokers, Real Estate Companies and other Enterprises selling Real estate
</a>, <a href="http://ordasoft.com/Real-Estate-Manager/realestatemanager-basic-and-pro-feature-comparison.html">Real Estate Manager create own real estate web portal for sell, rent,  buy real estate and property</a></noscript>

<script type="text/javascript">
    function remFireEvent(el,event) {

        if ("createEvent" in document) {
            el.click();
            var evt = document.createEvent("HTMLEvents");
            evt.initEvent(event, true, true);// event type,bubbling,cancelable
            return el.dispatchEvent(evt);
        }
        else{
          // dispatch for IE
          var evt = document.createEventObject();
          return el.fireEvent("on"+event,evt);
       }
    }

    function remOpenItem() {
        var tmpLinks=document.getElementsByTagName('a');

        for(var i=0;i<tmpLinks.length;i++){
          if(tmpLinks[i].name=='rem_link_item'){
            setTimeout(function(){remFireEvent(tmpLinks[i],'click')},50);
            return ;
          }
        }
    }

</script>

  </div>

<?php
$map_uniq_id = $pr;
?>

<style>#map_canvas<?php echo $pr; ?> img{max-width:none;}</style>
<?php if ($params->get('is_percentage') == 'pixels') { ?>
<div class="re_mod_rem_map_canvas"  id="map_canvas<?php echo $pr; ?>" style=
      "width: <?php echo $params->get('map_width');?>px; height: <?php echo $params->get('map_height'); ?>px;
       float: rigth;" >
</div>

<?php } else if ($params->get('is_percentage') == 'percentage') {  ?>
<div class="re_mod_rem_map_canvas"  id="map_canvas<?php echo $pr; ?>" style=
      "width:100%; height: <?php echo $params->get('map_height'); ?>px;
       float: rigth;" >
</div>
<?php } ?>

<?php
    if ( $params->get('GeoCodingBy') == 1 ){
    //for open map add div for Popup
?>
    <div id="os_ol_popup<?php echo $map_uniq_id; ?>" class="os_ol_popup">
      <a href="#" id="os_ol_popup-closer<?php echo $map_uniq_id; ?>" class="os_ol_popup-closer"></a>
      <div id="os_ol_popup-content<?php echo $map_uniq_id; ?>"></div>
    </div>
<?php
//        HTML_realestatemanager::add_open_map($rows,$map_uniq_id);
        require getLayoutPath::getLayoutPathCom('com_realestatemanager', 'map', 'open_map');
    } else {
//        HTML_realestatemanager::add_google_map($rows,$map_uniq_id);
        require getLayoutPath::getLayoutPathCom('com_realestatemanager', 'map', 'google_map');
    }
?>
